"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from compassapisdk.types import BaseModel, Nullable, UNSET_SENTINEL
from compassapisdk.utils import FieldMetadata, QueryParamMetadata
from enum import Enum
from pydantic import model_serializer
from typing_extensions import Annotated, TypedDict


class MorphoMarketsChain(str, Enum):
    ETHEREUM_MAINNET = "ethereum:mainnet"
    BASE_MAINNET = "base:mainnet"


class MorphoMarketsRequestTypedDict(TypedDict):
    collateral_token: Nullable[str]
    r"""Collateral token to identify the market."""
    loan_token: Nullable[str]
    r"""Loan token to identify the market."""
    chain: MorphoMarketsChain


class MorphoMarketsRequest(BaseModel):
    collateral_token: Annotated[
        Nullable[str],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ]
    r"""Collateral token to identify the market."""

    loan_token: Annotated[
        Nullable[str],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ]
    r"""Loan token to identify the market."""

    chain: Annotated[
        MorphoMarketsChain,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = MorphoMarketsChain.ETHEREUM_MAINNET

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = []
        nullable_fields = ["collateral_token", "loan_token"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
