"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .chain import Chain
from .token_enum import TokenEnum
from compassapisdk.types import BaseModel
from typing import Union
from typing_extensions import TypeAliasType, TypedDict


TokenTransferRequestAmountTypedDict = TypeAliasType(
    "TokenTransferRequestAmountTypedDict", Union[float, str]
)
r"""Amount of token to transfer"""


TokenTransferRequestAmount = TypeAliasType(
    "TokenTransferRequestAmount", Union[float, str]
)
r"""Amount of token to transfer"""


TokenTransferRequestTokenTypedDict = TypeAliasType(
    "TokenTransferRequestTokenTypedDict", Union[TokenEnum, str]
)
r"""The symbol of the token to transfer.."""


TokenTransferRequestToken = TypeAliasType(
    "TokenTransferRequestToken", Union[TokenEnum, str]
)
r"""The symbol of the token to transfer.."""


class TokenTransferRequestTypedDict(TypedDict):
    r"""Request model for transferring ETH or ERC20 tokens."""

    amount: TokenTransferRequestAmountTypedDict
    r"""Amount of token to transfer"""
    token: TokenTransferRequestTokenTypedDict
    r"""The symbol of the token to transfer.."""
    to: str
    r"""The recipient of the tokens."""
    chain: Chain
    r"""The chain to use."""
    sender: str
    r"""The address of the transaction sender."""


class TokenTransferRequest(BaseModel):
    r"""Request model for transferring ETH or ERC20 tokens."""

    amount: TokenTransferRequestAmount
    r"""Amount of token to transfer"""

    token: TokenTransferRequestToken
    r"""The symbol of the token to transfer.."""

    to: str
    r"""The recipient of the tokens."""

    chain: Chain
    r"""The chain to use."""

    sender: str
    r"""The address of the transaction sender."""
