"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .feeenum import FeeEnum
from .token_enum import TokenEnum
from compassapisdk.types import BaseModel
from typing import Optional, Union
from typing_extensions import NotRequired, TypeAliasType, TypedDict


UniswapBuyExactlyParamsAmountTypedDict = TypeAliasType(
    "UniswapBuyExactlyParamsAmountTypedDict", Union[float, str]
)
r"""The amount of the token to swap to"""


UniswapBuyExactlyParamsAmount = TypeAliasType(
    "UniswapBuyExactlyParamsAmount", Union[float, str]
)
r"""The amount of the token to swap to"""


class UniswapBuyExactlyParamsTypedDict(TypedDict):
    token_in: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """
    token_out: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """
    fee: FeeEnum
    r"""The transaction fee of a Uniswap pool in bips.

    Uniswap supports 4 different fee levels.
    """
    amount: UniswapBuyExactlyParamsAmountTypedDict
    r"""The amount of the token to swap to"""
    max_slippage_percent: float
    r"""The maximum slippage allowed in percent. e.g. `1` means `1 %` slippage allowed."""
    wrap_eth: NotRequired[bool]
    r"""Whether to wrap ETH to WETH, only use when swapping WETH into something"""


class UniswapBuyExactlyParams(BaseModel):
    token_in: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    token_out: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    fee: FeeEnum
    r"""The transaction fee of a Uniswap pool in bips.

    Uniswap supports 4 different fee levels.
    """

    amount: UniswapBuyExactlyParamsAmount
    r"""The amount of the token to swap to"""

    max_slippage_percent: float
    r"""The maximum slippage allowed in percent. e.g. `1` means `1 %` slippage allowed."""

    wrap_eth: Optional[bool] = False
    r"""Whether to wrap ETH to WETH, only use when swapping WETH into something"""
